=== build/templates/MEGAShellExtThunar/PKGBUILD ===
##
 # @file build/MEGAsync/MEGAsync/PKGBUILD
 # @brief script to generate package thunar-megasync for ArchLinux
 #
 # (c) 2013-2016 by Mega Limited, Auckland, New Zealand
 #
 # This file is part of the MEGA SDK - Client Access Engine.
 #
 # Applications using the MEGA API must present a valid application key
 # and comply with the the rules set forth in the Terms of Service.
 #
 # The MEGA SDK is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 #
 # @copyright Simplified (2-clause) BSD License.
 #
 # You should have received a copy of the license along with this
 # program.
##

pkgname=thunar-megasync
pkgver=EXT_VERSION
pkgrel=`cat MEGA_BUILD_ID || echo "1"`
epoch=
pkgdesc="Extension for Thunar to interact with Megasync"
arch=('i686' 'x86_64')
url="http://mega.nz/#sync"
license=() #TODO
depends=('thunar' 'megasync>=3.5')
makedepends=( 'ca-certificates' 'qt5-tools' 'thunar')
provides=("thunar-megasync=${pkgver}")
conflicts=()
replaces=()
backup=()
options=()
install=thunarext.install
changelog= #TODO
source=("./${pkgname}_$pkgver.tar.gz")
noextract=()
md5sums=('MD5SUM')
validpgpkeys=()

prepare() {
	cd "$pkgname-$pkgver"
}

build() {
	cd "$pkgname-$pkgver"
	qmake || qmake-qt4 #qmake would fail when qt4 installed (due to some path missconfigurations)	
	make
}

check() {
	cd "$pkgname-$pkgver"
}

package() {
	cd "$pkgname-$pkgver"
	for i in libMEGAShellExtThunar.so*; do install -D $i $pkgdir`pkg-config --variable=extensionsdir thunarx-3`/$i; done
}
